<?php

/**
 * Front-end of Flexslider_XH.
 *
 * PHP version 5
 *
 * @category  CMSimple_XH
 * @author    svasti <svasti@svasti.de>
 * @copyright 2014 svasti <http://svasti.de>
 */

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

function flexslider($images='')
{
    global $plugin_cf,$hjs,$pth,$sl;
    $o = $t = '';

    $images = $images
            ? strpos($images,'.php')
            ? $images
            : $images.'.php'
            : 'flexslider_'.$sl.'.php';
    $imagefile_pth = $plugin_cf['flexslider']['path_flexslider_data_files']
                   ? $plugin_cf['flexslider']['path_flexslider_data_files']
                   : $pth['folder']['userfiles'].'plugins/flexslider/';

    $i = json_decode(file_get_contents($imagefile_pth.$images),true);
    $totalslides = count($i['image1']);

    $random      = isset($i['random']) && $i['random'] ? 'randomize: true,'."\n" : '';
    $randomstart = isset($i['randomstart']) && $i['randomstart'] ? 'startAt:'. mt_rand(0,$totalslides - 1) . ",\n" : '';
    $halt        = isset($i['halt']) && $i['halt'] ? 'pauseOnHover: true,'."\n" : '';
    $cnav        = isset($i['cnav']) && $i['cnav'] ?  '' : 'controlNav:false,'."\n";
    $dnav        = isset($i['dnav']) && $i['dnav'] ?  '' : 'directionNav:false,'."\n";
    $height      = isset($i['display']) && $i['display'] == 'flexible' ?  'smoothHeight: true,'."\n" : '';

    $extranav = $extranav1 = $extranav2 = '';
    $resume = $halt
            ? 'start: function(slider) {
              slider.mouseout(function() {
              slider.resume();
              });
              }'
            : '';

    switch ($i['type']) {
        case 'vertical':
            $type = 'animation:"slide",'."\n".' direction: "vertical",'."\n";
        	break;
        case 'reverse':
            $type = 'animation:"slide",'."\n".' reverse:true,'."\n";
        	break;
        case 'static':
            $resume = '';
            $type = 'slideshow:false,'."\n".'animationSpeed:0,'."\n";
            if(!$dnav) {
                $extranav = '$(document).on(\'click\',\'.next\',function(){
                                $(\'.flex-direction-nav .flex-next:first\').trigger(\'click\');
                                return false;
                            });
                            $(document).on(\'click\',\'.prev\',function(){
                                $(\'.flex-direction-nav .flex-prev:first\').trigger(\'click\');
                                return false;
                            });';
                $extranav1 = 'controlsContainer: ".extradirnav",
                              after: function(slider) {
                                  $(".current-slide").text(slider.currentSlide + 1);
                              }';

                $extranav2 = '<div class="extradirnav">'
                           . '<a href="" class="prev">&#xf001; <span class="current-slide">1</span></a>/'
                           . '<a href="" class="next">'.$totalslides.' &#xf002;</a>'
                           . '</div>';
                $hjs .= '<style type="text/css">.flex-direction-nav {opacity:0;}.</style>';
            }
        	break;
        default:
            $type = 'animation:"'.$i['type'].'",'."\n";
        	break;
    }


    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    include_jQueryPlugin('flexslider-min', $pth['folder']['plugins'].'flexslider/js/jquery.flexslider-min.js');

    $speed_slideshow = $plugin_cf['flexslider']['speed_slideshow'] 
                     ? 'slideshowSpeed: '.$plugin_cf['flexslider']['speed_slideshow'].",\n"
                     : '';
    $speed_animation = $plugin_cf['flexslider']['speed_animation'] 
                     ? 'animationSpeed: '.$plugin_cf['flexslider']['speed_animation'].",\n"
                     : '';

        $x = '<script type="text/javascript">
    // Can also be used with $(document).ready()
    $(window).load(function() {
      $(\'.flexslider\').flexslider({
            initDelay: 0,'. "\n"
          . $randomstart
          . $speed_slideshow
          . $speed_animation
          . $halt
          . $random
          . $cnav
          . $dnav
          . $type
          . $height
          . 'prevText: "",
             nextText: "",'
          . $extranav1
          . $resume
        . '});'
        . $extranav
    .'});
    </script>';
    //$o .= nl2br(htmlspecialchars($x));

    if(isset($plugin_cf['flexslider']['used_in_template_or_newsbox'])) $o .= $x; else $hjs .= $x;

    foreach ($i['image1'] as $k=>$value) {

        $cursor = '';
    	$t .= "\n<li>";
        if(isset($i['link'][$k]) && $i['link'][$k]) {
            $t .= strpos($i['link'][$k],'h')===0
                ? '<a href="'.$i['link'][$k].'" target="_blank">'
                : '<a href="'.$i['link'][$k].'">';
        } else $cursor = $halt? 'cursor:no-drop;' : '';
      	if(isset($i['image1'][$k]) && $i['image1'][$k]) {
            $width = isset($i['width'][$k])? 'style="width:'.$i['width'][$k].'%;margin:0 auto;"' : '';
            $t .= '<div style="width:100%;'.$cursor.'">';
            /*$t .= '<div style="position:absolute;margin-left:50%; border: 1px solid blue;">
                    <div style="padding:10%">
                  vdiv yxc  yc yc yc yc yc yc yc yc y ad ad xv xv sf y  y yc yc yc
                  yc yc yc v xv xvsdf sfsaf sd xvc xvc c yc yc yc yc xv xcvsf yc ycycx
                   yc yc sfgf  yxc yc yc ycsa  xcv xvxvyc yxc yca ad ds ycx sfölksfölskfsf </div></div>';
            */
            $t .= tag('img '. $width .' src="' . $pth['folder']['images'].$i['image1'][$k] . '"');
            $t .= '</div>';
            if(isset($i['text'][$k]) && $i['text'][$k]) $t .= '<p class="flex-caption flex-'.$i['caption'].'">' . $i['text'][$k] . '</p>';
        } else {
            if(isset($i['text'][$k]) && $i['text'][$k]) {
                $t .= '<div class="flex-text" style="margin:'.$i['margintop'][$k].'% '.$i['marginhorz'][$k].'% 0;">' . $i['text'][$k] . '</div>';
            } 
        }
        if(isset($i['link'][$k]) && $i['link'][$k]) $t .='</a>';
        $t .= '</li>';
     }

    $o .= "\n\n\n<!-- F L E X S L I D E R   S T A R T -->\n\n"
       .  '<div class="flexslider">'
       .  '<ul class="slides">'
       .  $t
       .  '</ul>'
       .  $extranav2
       .  '</div>'
       .  "\n<!-- F L E X S L I D E R   E N D -->\n\n";


    return $o;
}

/**
 * function only for use of the plugin in a template, has to be called in the <head> area
 *
 */
function flexslider_init()
{
    global $pth,$plugin_cf;

    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    include_jQueryPlugin('flexslider-min', $pth['folder']['plugins'].'flexslider/js/jquery.flexslider-min.js');

    $plugin_cf['flexslider']['used_in_template_or_newsbox'] = 'true';
}
?>